VERSION 5.00
Object = "{648A5603-2C6E-101B-82B6-000000000014}#1.1#0"; "MSCOMM32.OCX"
Begin VB.Form Form1 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "Furrtek's PC2GBPrinter"
   ClientHeight    =   6915
   ClientLeft      =   7320
   ClientTop       =   4905
   ClientWidth     =   6090
   Icon            =   "pc2gbprinter.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   461
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   406
   Begin VB.PictureBox Picture1 
      BackColor       =   &H00FFFFFF&
      Height          =   6615
      Left            =   240
      ScaleHeight     =   437
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   165
      TabIndex        =   2
      Top             =   120
      Width           =   2535
      Begin VB.Image Image1 
         Height          =   5715
         Left            =   0
         Picture         =   "pc2gbprinter.frx":000C
         Top             =   0
         Width           =   2400
      End
   End
   Begin MSCommLib.MSComm MSComm1 
      Left            =   3480
      Top             =   120
      _ExtentX        =   1005
      _ExtentY        =   1005
      _Version        =   393216
      DTREnable       =   -1  'True
      RThreshold      =   1
   End
   Begin VB.TextBox Text1 
      BeginProperty Font 
         Name            =   "Fixedsys"
         Size            =   9
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   1695
      Left            =   3480
      MultiLine       =   -1  'True
      ScrollBars      =   2  'Vertical
      TabIndex        =   1
      Top             =   2040
      Width           =   1935
   End
   Begin VB.CommandButton Command1 
      Caption         =   "Start"
      Height          =   735
      Left            =   3480
      TabIndex        =   0
      Top             =   1200
      Width           =   1335
   End
   Begin VB.Line Line1 
      BorderColor     =   &H000000FF&
      X1              =   192
      X2              =   192
      Y1              =   8
      Y2              =   24
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'PC2GBPrinter CC BY furrtek 2009 v1.0
'http://www.furrtek.org

Dim inp As String
Private Sub Command1_Click()
    Dim ref As Double
    Dim c(16) As Byte
    
    '38400Bps, 8 bit, 0 parity, 1 stop, COM2
    If MSComm1.PortOpen = True Then MSComm1.PortOpen = False
    MSComm1.Settings = "38400,N,8,1"
    MSComm1.CommPort = 2
    MSComm1.PortOpen = True

    'Send 25 bands of 16 pixels
    For bands = 0 To 25
        Image1.Top = -(bands * 16)
        
        ref = Timer
        Do
            DoEvents
        Loop While Timer < ref + 0.2
        
        'Send "A", and wait for "B"
        MSComm1.Output = "A"
        
        Do
            DoEvents
        Loop Until GetByte = "B"
        
        ref = Timer
        Do
            DoEvents
        Loop While Timer < ref + 0.2
        
        For lines = 0 To 1
            For tiles = 0 To 19
            i = 0
                For ta = 0 To 7 'Tile line loop
                ca = 0
                cb = 0
                For pixels = 0 To 7 'Tile pixel loop
                    ca = ca * 2
                    cb = cb * 2
                    couleur = Hex(Picture1.Point(pixels + (tiles * 8), ta + (lines * 8)))
                    'Pad color value with zeroes
                    If Len(couleur) < 6 Then
                        Do
                           couleur = "0" & couleur
                        Loop Until Len(couleur) = 6
                    End If
                    'Get rgb values
                    rouge = Val("&h" & Left(couleur, 2))
                    vert = Val("&h" & Mid(couleur, 3, 2))
                    bleu = Val("&h" & Right(couleur, 2))
                    'Get mean
                    clv = (rouge + bleu + vert) / 3
                    'Make 2BPP value from mean
                    If clv < 64 Then
                        ca = ca + 1
                        cb = cb + 1
                    ElseIf clv >= 64 And clv < 128 Then
                        cb = cb + 1
                    ElseIf clv >= 128 And clv < 192 Then
                        ca = ca + 1
                    ElseIf clv >= 192 Then
                        'Leave ca and cb at 0
                    End If
                Next pixels
                'Send the two bytes defining the pixel line
                MSComm1.Output = Chr$(ca)
                MSComm1.Output = Chr$(cb)
                Form1.Caption = tiles
                Next ta
            Next tiles
        Next lines
        'Wait for printing done before next band
        Do
            DoEvents
        Loop Until MSComm1.Input = "D"
    Next bands
End Sub

Private Sub Command2_Click()
    MSComm1.PortOpen = False
End Sub

Sub addtext(texte As String)
    Text1.Text = Text1.Text & texte & vbCrLf
End Sub

Function GetByte() As String
    Do
        DoEvents
        inp = MSComm1.Input
    Loop Until inp <> ""
    GetByte = inp
End Function

Private Sub Form_Load()

End Sub
